Revenue by Region in JavaScript

Using ApexCharts with JavaScript

This Revenue by Region example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// One dataset, six panels: `trellis.by: 'region'` splits the series into one
// pixel-aligned panel per region. Every panel shares the SAME y scale (so
// "the West is bigger" stays true while shapes are compared), the same x
// window, one legend and one crosshair that sweeps all six panels: hover any
// panel and read the same month everywhere. The keyless 'Target' series
// carries no region, so it repeats in every panel as a reference line.
//
// Deterministic monthly revenue walks so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

var REGIONS = [
  { name: 'North', seed: 11, base: 58 },
  { name: 'South', seed: 23, base: 42 },
  { name: 'East', seed: 35, base: 74 },
  { name: 'West', seed: 47, base: 90 },
  { name: 'Central', seed: 59, base: 35 },
  { name: 'Northeast', seed: 71, base: 62 },
]

function monthlyRevenue(seed, base) {
  var rand = mulberry32(seed)
  var out = []
  var ts = new Date('01 Jan 2025').getTime()
  var val = base
  for (var i = 0; i < 12; i++) {
    val += (rand() - 0.45) * 9
    out.push([ts, Math.round(val * 10) / 10])
    ts += 2678400000 // ~1 month
  }
  return out
}

var trellisSeries = REGIONS.map(function (r) {
  return {
    name: 'Revenue',
    region: r.name,
    data: monthlyRevenue(r.seed, r.base),
  }
})

// Reference series: no `region` key, so it repeats in every panel.
trellisSeries.push({
  name: 'Target',
  data: monthlyRevenue(1, 65).map(function (d) {
    return [d[0], 65]
  }),
})

var options = {
  series: trellisSeries,
  chart: {
    id: 'revenueTrellis',
    type: 'line',
    height: 640,
    animations: {
      enabled: false,
    },
  },
  trellis: {
    by: 'region',
    minPanelWidth: 260,
    gap: 14,
    header: {
      formatter: function (key) {
        return key
      },
    },
  },
  colors: ['#0EA5E9', '#94A3B8'],
  stroke: {
    width: [3, 2],
    curve: 'straight',
    dashArray: [0, 5],
  },
  xaxis: {
    type: 'datetime',
  },
  yaxis: {
    labels: {
      formatter: function (val) {
        return '$' + Math.round(val) + 'k'
      },
    },
  },
  dataLabels: {
    enabled: false,
  },
  tooltip: {
    x: {
      format: 'MMM yyyy',
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Revenue by Region in Vue

Using ApexCharts with Vue

This Revenue by Region example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>Revenue by region</h1>
      <p class="lead">
        Six regions, one shared scale: each panel is a real chart, and all six
        are pixel-aligned so the shapes compare honestly. Hover anywhere: the
        crosshair sweeps every panel at the same month.
      </p>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="line"
            height="640"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <div class="note">
        A trellis (small multiples) splits one dataset into a grid of panels:
        <code>trellis.by: 'region'</code> is the whole configuration. The
        trellis owns everything shared: the y domain (union of all panels, so
        panels never lie), the x window, one legend (click
        <code>Target</code> to hide it in every panel), one zoom/pan/reset
        toolbar, and the responsive column count (resize the window: 3 &rarr; 2
        &rarr; 1 columns from <code>minPanelWidth</code> alone). The keyless
        <code>Target</code> series repeats in every panel as a reference line.
        Trellis is a premium feature; without a license it renders with a trial
        watermark.
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

import 'apexcharts/features/trellis'

// One dataset, six panels: `trellis.by: 'region'` splits the series into one
// pixel-aligned panel per region. Every panel shares the SAME y scale (so
// "the West is bigger" stays true while shapes are compared), the same x
// window, one legend and one crosshair that sweeps all six panels: hover any
// panel and read the same month everywhere. The keyless 'Target' series
// carries no region, so it repeats in every panel as a reference line.
//
// Deterministic monthly revenue walks so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

var REGIONS = [
  { name: 'North', seed: 11, base: 58 },
  { name: 'South', seed: 23, base: 42 },
  { name: 'East', seed: 35, base: 74 },
  { name: 'West', seed: 47, base: 90 },
  { name: 'Central', seed: 59, base: 35 },
  { name: 'Northeast', seed: 71, base: 62 },
]

function monthlyRevenue(seed, base) {
  var rand = mulberry32(seed)
  var out = []
  var ts = new Date('01 Jan 2025').getTime()
  var val = base
  for (var i = 0; i < 12; i++) {
    val += (rand() - 0.45) * 9
    out.push([ts, Math.round(val * 10) / 10])
    ts += 2678400000 // ~1 month
  }
  return out
}

var trellisSeries = REGIONS.map(function (r) {
  return {
    name: 'Revenue',
    region: r.name,
    data: monthlyRevenue(r.seed, r.base),
  }
})

// Reference series: no `region` key, so it repeats in every panel.
trellisSeries.push({
  name: 'Target',
  data: monthlyRevenue(1, 65).map(function (d) {
    return [d[0], 65]
  }),
})

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: trellisSeries,
      chartOptions: {
        chart: {
          id: 'revenueTrellis',
          type: 'line',
          height: 640,
          animations: {
            enabled: false,
          },
        },
        trellis: {
          by: 'region',
          minPanelWidth: 260,
          gap: 14,
          header: {
            formatter: function (key) {
              return key
            },
          },
        },
        colors: ['#0EA5E9', '#94A3B8'],
        stroke: {
          width: [3, 2],
          curve: 'straight',
          dashArray: [0, 5],
        },
        xaxis: {
          type: 'datetime',
        },
        yaxis: {
          labels: {
            formatter: function (val) {
              return '$' + Math.round(val) + 'k'
            },
          },
        },
        dataLabels: {
          enabled: false,
        },
        tooltip: {
          x: {
            format: 'MMM yyyy',
          },
        },
      },
    }
  },
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 960px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
.lead {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 20px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.note {
  background: #eef2ff;
  border-left: 3px solid #0ea5e9;
  padding: 12px 16px;
  font-size: 13px;
  color: #333;
  border-radius: 2px;
  line-height: 1.6;
  margin: 26px auto 0;
}
.note code {
  background: #e0e7ff;
  padding: 1px 5px;
  border-radius: 3px;
}
</style>

Revenue by Region in Angular

Using ApexCharts with Angular

This Revenue by Region example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private mulberry32 = (seed: any): any => {
        return function () {
          seed |= 0
          seed = (seed + 0x6d2b79f5) | 0
          var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
          t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
          return ((t ^ (t >>> 14)) >>> 0) / 4294967296
        }
      };

  private REGIONS: any = [
        { name: 'North', seed: 11, base: 58 },
        { name: 'South', seed: 23, base: 42 },
        { name: 'East', seed: 35, base: 74 },
        { name: 'West', seed: 47, base: 90 },
        { name: 'Central', seed: 59, base: 35 },
        { name: 'Northeast', seed: 71, base: 62 },
      ];

  private monthlyRevenue = (seed: any, base: any): any => {
        var rand = this.mulberry32(seed)
        var out = []
        var ts = new Date('01 Jan 2025').getTime()
        var val = base
        for (var i = 0; i < 12; i++) {
          val += (rand() - 0.45) * 9
          out.push([ts, Math.round(val * 10) / 10])
          ts += 2678400000 // ~1 month
        }
        return out
      };

  private trellisSeries: any = this.REGIONS.map(function (r) {
        return {
          name: 'Revenue',
          region: r.name,
          data: this.monthlyRevenue(r.seed, r.base),
        }
      });

  public chartOptions: Partial<ChartOptions> = {
          series: this.trellisSeries,
          chart: {
            id: 'revenueTrellis',
            type: 'line',
            height: 640,
            animations: {
              enabled: false,
            },
          },
          trellis: {
            by: 'region',
            minPanelWidth: 260,
            gap: 14,
            header: {
              formatter: (key) => {
                return key
              },
            },
          },
          colors: ['#0EA5E9', '#94A3B8'],
          stroke: {
            width: [3, 2],
            curve: 'straight',
            dashArray: [0, 5],
          },
          xaxis: {
            type: 'datetime',
          },
          yaxis: {
            labels: {
              formatter: (val) => {
                return '$' + Math.round(val) + 'k'
              },
            },
          },
          dataLabels: {
            enabled: false,
          },
          tooltip: {
            x: {
              format: 'MMM yyyy',
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
    this.trellisSeries.push({
          name: 'Target',
          data: this.monthlyRevenue(1, 65).map(function (d) {
            return [d[0], 65]
          }),
        })
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Revenue by Region in React

Using ApexCharts with React

This Revenue by Region example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

import 'apexcharts/features/trellis'

// One dataset, six panels: `trellis.by: 'region'` splits the series into one
// pixel-aligned panel per region. Every panel shares the SAME y scale (so
// "the West is bigger" stays true while shapes are compared), the same x
// window, one legend and one crosshair that sweeps all six panels: hover any
// panel and read the same month everywhere. The keyless 'Target' series
// carries no region, so it repeats in every panel as a reference line.
//
// Deterministic monthly revenue walks so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

var REGIONS = [
  { name: 'North', seed: 11, base: 58 },
  { name: 'South', seed: 23, base: 42 },
  { name: 'East', seed: 35, base: 74 },
  { name: 'West', seed: 47, base: 90 },
  { name: 'Central', seed: 59, base: 35 },
  { name: 'Northeast', seed: 71, base: 62 },
]

function monthlyRevenue(seed, base) {
  var rand = mulberry32(seed)
  var out = []
  var ts = new Date('01 Jan 2025').getTime()
  var val = base
  for (var i = 0; i < 12; i++) {
    val += (rand() - 0.45) * 9
    out.push([ts, Math.round(val * 10) / 10])
    ts += 2678400000 // ~1 month
  }
  return out
}

var trellisSeries = REGIONS.map(function (r) {
  return {
    name: 'Revenue',
    region: r.name,
    data: monthlyRevenue(r.seed, r.base),
  }
})

// Reference series: no `region` key, so it repeats in every panel.
trellisSeries.push({
  name: 'Target',
  data: monthlyRevenue(1, 65).map(function (d) {
    return [d[0], 65]
  }),
})

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: trellisSeries,
    options: {
      chart: {
        id: 'revenueTrellis',
        type: 'line',
        height: 640,
        animations: {
          enabled: false,
        },
      },
      trellis: {
        by: 'region',
        minPanelWidth: 260,
        gap: 14,
        header: {
          formatter: function (key) {
            return key
          },
        },
      },
      colors: ['#0EA5E9', '#94A3B8'],
      stroke: {
        width: [3, 2],
        curve: 'straight',
        dashArray: [0, 5],
      },
      xaxis: {
        type: 'datetime',
      },
      yaxis: {
        labels: {
          formatter: function (val) {
            return '$' + Math.round(val) + 'k'
          },
        },
      },
      dataLabels: {
        enabled: false,
      },
      tooltip: {
        x: {
          format: 'MMM yyyy',
        },
      },
    },
  })

  return (
    <div>
      <div className="wrap">
        <h1>Revenue by region</h1>
        <p className="lead">
          Six regions, one shared scale: each panel is a real chart, and all six
          are pixel-aligned so the shapes compare honestly. Hover anywhere: the
          crosshair sweeps every panel at the same month.
        </p>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="line"
              height={640}
            />
          </div>
        </div>

        <div className="note">
          A trellis (small multiples) splits one dataset into a grid of panels:
          <code>trellis.by: 'region'</code> is the whole configuration. The
          trellis owns everything shared: the y domain (union of all panels, so
          panels never lie), the x window, one legend (click <code>Target</code>{' '}
          to hide it in every panel), one zoom/pan/reset toolbar, and the
          responsive column count (resize the window: 3 &rarr; 2 &rarr; 1
          columns from
          <code>minPanelWidth</code> alone). The keyless <code>Target</code>{' '}
          series repeats in every panel as a reference line. Trellis is a
          premium feature; without a license it renders with a trial watermark.
        </div>
      </div>
    </div>
  )
}

export default ApexChart